; PureBasic Visual Designer v3.81 build 1321


; Importiere CCValid.DLL
#carddll = 0
datei.s = "CCValid.DLL"

If OpenLibrary(#carddll, datei)
   ;MessageRequester("Info", "CCValid.DLL geladen !", 64)
Else
   MessageRequester("Fehler", "CCValid.DLL nicht gefunden !", 16)
   End
EndIf   
    
Procedure.w CheckCard(CCNumber.s)
   ProcedureReturn = CallFunction(#carddll, "CheckCard", CCNumber)
EndProcedure

Procedure.w CheckNumber(CCNumber.s)
  ProcedureReturn = CallFunction(#carddll, "CheckNumber", CCNumber)
EndProcedure

Procedure.l CheckOrganization(CCNumber.s)
  ProcedureReturn = CallFunction(#carddll, "CheckOrganization", CCNumber)
EndProcedure

Procedure.w IsAmex(CCNumber.s)
   ProcedureReturn = CallFunction(#carddll, "IsAmex", CCNumber)
EndProcedure
   
Procedure.w IsDC(CCNumber.s)
  ProcedureReturn = CallFunction(#carddll, "IsDC", CCNumber)
EndProcedure

Procedure.w IsDisc(CCNumber.s)
   ProcedureReturn = CallFunction(#carddll, "IsDisc", CCNumber)
EndProcedure

Procedure.w IsJCB(CCNumber.s)
   ProcedureReturn = CallFunction(#carddll, "IsJCB", CCNumber)
EndProcedure
      
Procedure.w IsMC(CCNumber.s)
  ProcedureReturn = CallFunction(#carddll, "IsMC", CCNumber)
EndProcedure

Procedure.w IsVisa(CCNumber.s)
  ProcedureReturn = CallFunction(#carddll, "IsVisa", CCNumber)
EndProcedure

;- Window Constants
;
Enumeration
  #Window_0
EndEnumeration

;- Gadget Constants
;
Enumeration
  #Frame3D_0
  #Radio_0
  #Radio_1
  #Radio_2
  #Radio_3
  #Radio_4
  #Radio_5
  #Radio_6
  #Frame3D_2
  #String_0
  #Button_0
  #Button_1
  #Button_2
  #Button_3
  #Button_4
  #Text_0
EndEnumeration

; Ereignisprozeduren
Procedure.s DetermineOrganization (CCNumber.s)
Protected org.s
; Alle Optionen deaktivieren
SetGadgetState(#Radio_0,0)
SetGadgetState(#Radio_1,0)
SetGadgetState(#Radio_2,0)
SetGadgetState(#Radio_3,0)
SetGadgetState(#Radio_4,0)
SetGadgetState(#Radio_5,0)
SetGadgetState(#Radio_6,0)
; Bestimmen der Organisation
If IsAmex(CCNumber)
   org = "Amex"
   SetGadgetState(#Radio_0,1)
ElseIf IsDC(CCNumber) 
   org = "Diners Club"
   SetGadgetState(#Radio_1,1)
ElseIf IsDisc(CCNumber)
   org = "Discover"
   SetGadgetState(#Radio_2,1)
ElseIf IsJCB(CCNumber) 
   org = "JCB"
   SetGadgetState(#Radio_3,1)
ElseIf IsMC(CCNumber)
   org = "Mastercard"
   SetGadgetState(#Radio_4,1)
ElseIf IsVisa(CCNumber)
   org = "Visa"
   SetGadgetState(#Radio_5,1)
Else
   org = "Unknown"
   SetGadgetState(#Radio_6,1)
EndIf
ProcedureReturn = org
EndProcedure

Procedure CheckAll(CCNumber.s)
Protected tmp.s, org.s, txt.s, MyIcon.l
tmp = Trim(CCNumber) 
;*** CheckCard
Select CheckCard(tmp)
  Case 0
    txt = "Not Valid !"
    MyIcon = 16  ;vbCritical
  Case -1
    txt = "Valid !"
    MyIcon = 64  ;vbInformation
EndSelect
;*** Determine the Credit card organization
org = DetermineOrganization(CCNumber)
MessageRequester ("Info" , org + " Credit card is " + txt, MyIcon + #PB_MessageRequester_Ok)
EndProcedure


;Procedure Open_Window_0()
  If OpenWindow(#Window_0, 216, 216, 423, 254,  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar , "CCValid.DLL - Demo")
    If CreateGadgetList(WindowID())
      Frame3DGadget(#Frame3D_0, 10, 10, 210, 170, " Credit card organization ")
      OptionGadget(#Radio_0, 30, 30, 170, 20, "Amex")
      OptionGadget(#Radio_1, 30, 50, 170, 20, "Diners Club")
      OptionGadget(#Radio_2, 30, 70, 170, 20, "Discover")
      OptionGadget(#Radio_3, 30, 90, 170, 20, "JCB")
      OptionGadget(#Radio_4, 30, 110, 170, 20, "Mastercard")
      OptionGadget(#Radio_5, 30, 130, 170, 20, "Visa")
      OptionGadget(#Radio_6, 30, 150, 170, 20, "Unknown")
      SetGadgetState(#Radio_6,1)
      Frame3DGadget(#Frame3D_2, 10, 190, 210, 50, " Card number ")
      StringGadget(#String_0, 20, 210, 190, 20, "378282246310005")
      ButtonGadget(#Button_0, 240, 10, 160, 20, "Check all")
      ButtonGadget(#Button_1, 240, 100, 160, 20, "Check number")
      ButtonGadget(#Button_2, 240, 130, 160, 20, "Check organization")
      ButtonGadget(#Button_3, 240, 160, 160, 20, "Determine organization")
      ButtonGadget(#Button_4, 240, 220, 160, 20, "Abort")
      TextGadget(#Text_0, 260, 60, 120, 20, "(C)EMSC-asy to use...(R)")
      
    EndIf


  Repeat
    EventID.l = WaitWindowEvent()
   Select EventID
      Case #PB_EventCloseWindow  
                 CloseLibrary(#carddll)
                 Quit = 1
      Case #PB_EventGadGet
         Select EventGadgetID()
           
           Case #Button_0     ; Check all
             checkall (GetGadgetText(#String_0))
           Case #Button_1     ; Check number
             If checknumber (GetGadgetText(#String_0))
                MessageRequester ("Info" , "Credit card number is valid !", 64 + #PB_MessageRequester_Ok)
             Else
                MessageRequester ("Error" , "Credit card number is NOT valid !", 16 + #PB_MessageRequester_Ok)
             EndIf   
           Case #Button_2     ; Check organization
             If checkorganization (GetGadgetText(#String_0))
                MessageRequester ("Info" , "Credit card organization is valid !", 64 + #PB_MessageRequester_Ok)
             Else
                MessageRequester ("Error" , "Credit card organization is NOT valid !", 16 + #PB_MessageRequester_Ok)
             EndIf   
           Case #Button_3     ; Determine organization
             determineorganization (GetGadgetText(#String_0))
           Case #Button_4
             ; Ende
             CloseLibrary(#carddll)
             Quit = 1
             
        EndSelect            
    EndSelect

  Until Quit = 1



  EndIf

;EndProcedure
; ExecutableFormat=Windows
; UseIcon=FACE03.ICO
; Executable=cc.exe
; EOF